/* collection.c generated by valac, the Vala compiler
 * generated from collection.vala, do not modify */

/* collection.vala
 *
 * Copyright (C) 2007  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <glib.h>
#include <glib-object.h>


#define VALA_TYPE_COLLECTION_OBJECT (vala_collection_object_get_type ())
#define VALA_COLLECTION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_COLLECTION_OBJECT, ValaCollectionObject))
#define VALA_COLLECTION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_COLLECTION_OBJECT, ValaCollectionObjectClass))
#define VALA_IS_COLLECTION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_COLLECTION_OBJECT))
#define VALA_IS_COLLECTION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_COLLECTION_OBJECT))
#define VALA_COLLECTION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_COLLECTION_OBJECT, ValaCollectionObjectClass))

typedef struct _ValaCollectionObject ValaCollectionObject;
typedef struct _ValaCollectionObjectClass ValaCollectionObjectClass;

#define VALA_TYPE_ITERABLE (vala_iterable_get_type ())
#define VALA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_ITERABLE, ValaIterable))
#define VALA_IS_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_ITERABLE))
#define VALA_ITERABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_ITERABLE, ValaIterableIface))

typedef struct _ValaIterable ValaIterable;
typedef struct _ValaIterableIface ValaIterableIface;

#define VALA_TYPE_ITERATOR (vala_iterator_get_type ())
#define VALA_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_ITERATOR, ValaIterator))
#define VALA_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_ITERATOR))
#define VALA_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_ITERATOR, ValaIteratorIface))

typedef struct _ValaIterator ValaIterator;
typedef struct _ValaIteratorIface ValaIteratorIface;

#define VALA_TYPE_COLLECTION (vala_collection_get_type ())
#define VALA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_COLLECTION, ValaCollection))
#define VALA_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_COLLECTION))
#define VALA_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_COLLECTION, ValaCollectionIface))

typedef struct _ValaCollection ValaCollection;
typedef struct _ValaCollectionIface ValaCollectionIface;

struct _ValaIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*next) (ValaIterator* self);
	gpointer (*get) (ValaIterator* self);
};

struct _ValaIterableIface {
	GTypeInterface parent_iface;
	GType (*get_element_type) (ValaIterable* self);
	ValaIterator* (*iterator) (ValaIterable* self);
};

struct _ValaCollectionIface {
	GTypeInterface parent_iface;
	gboolean (*contains) (ValaCollection* self, gconstpointer item);
	gboolean (*add) (ValaCollection* self, gconstpointer item);
	gboolean (*remove) (ValaCollection* self, gconstpointer item);
	void (*clear) (ValaCollection* self);
	gint (*get_size) (ValaCollection* self);
};



gpointer vala_collection_object_ref (gpointer instance);
void vala_collection_object_unref (gpointer instance);
GParamSpec* vala_param_spec_collection_object (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void vala_value_set_collection_object (GValue* value, gpointer v_object);
void vala_value_take_collection_object (GValue* value, gpointer v_object);
gpointer vala_value_get_collection_object (const GValue* value);
GType vala_collection_object_get_type (void) G_GNUC_CONST;
GType vala_iterator_get_type (void) G_GNUC_CONST;
GType vala_iterable_get_type (void) G_GNUC_CONST;
GType vala_collection_get_type (void) G_GNUC_CONST;
gboolean vala_collection_contains (ValaCollection* self, gconstpointer item);
gboolean vala_collection_add (ValaCollection* self, gconstpointer item);
gboolean vala_collection_remove (ValaCollection* self, gconstpointer item);
void vala_collection_clear (ValaCollection* self);
gint vala_collection_get_size (ValaCollection* self);



/**
 * Determines whether this collection contains the specified item.
 *
 * @param item the item to locate in the collection
 *
 * @return     true if item is found, false otherwise
 */
gboolean vala_collection_contains (ValaCollection* self, gconstpointer item) {
	return VALA_COLLECTION_GET_INTERFACE (self)->contains (self, item);
}


/**
 * Adds an item to this collection. Must not be called on read-only
 * collections.
 *
 * @param item the item to add to the collection
 *
 * @return     true if the collection has been changed, false otherwise
 */
gboolean vala_collection_add (ValaCollection* self, gconstpointer item) {
	return VALA_COLLECTION_GET_INTERFACE (self)->add (self, item);
}


/**
 * Removes the first occurence of an item from this collection. Must not
 * be called on read-only collections.
 *
 * @param item the item to remove from the collection
 *
 * @return     true if the collection has been changed, false otherwise
 */
gboolean vala_collection_remove (ValaCollection* self, gconstpointer item) {
	return VALA_COLLECTION_GET_INTERFACE (self)->remove (self, item);
}


/**
 * Removes all items from this collection. Must not be called on
 * read-only collections.
 */
void vala_collection_clear (ValaCollection* self) {
	VALA_COLLECTION_GET_INTERFACE (self)->clear (self);
}


gint vala_collection_get_size (ValaCollection* self) {
	return VALA_COLLECTION_GET_INTERFACE (self)->get_size (self);
}


static void vala_collection_base_init (ValaCollectionIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * Serves as the base interface for implementing collection classes. Defines
 * size, iteration, and modification methods.
 */
GType vala_collection_get_type (void) {
	static volatile gsize vala_collection_type_id__volatile = 0;
	if (g_once_init_enter (&vala_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaCollectionIface), (GBaseInitFunc) vala_collection_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType vala_collection_type_id;
		vala_collection_type_id = g_type_register_static (G_TYPE_INTERFACE, "ValaCollection", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (vala_collection_type_id, VALA_TYPE_ITERABLE);
		g_once_init_leave (&vala_collection_type_id__volatile, vala_collection_type_id);
	}
	return vala_collection_type_id__volatile;
}




