/* set.c generated by valac, the Vala compiler
 * generated from set.vala, do not modify */

/* set.vala
 *
 * Copyright (C) 2007  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <glib.h>
#include <glib-object.h>


#define VALA_TYPE_COLLECTION_OBJECT (vala_collection_object_get_type ())
#define VALA_COLLECTION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_COLLECTION_OBJECT, ValaCollectionObject))
#define VALA_COLLECTION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_COLLECTION_OBJECT, ValaCollectionObjectClass))
#define VALA_IS_COLLECTION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_COLLECTION_OBJECT))
#define VALA_IS_COLLECTION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_COLLECTION_OBJECT))
#define VALA_COLLECTION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_COLLECTION_OBJECT, ValaCollectionObjectClass))

typedef struct _ValaCollectionObject ValaCollectionObject;
typedef struct _ValaCollectionObjectClass ValaCollectionObjectClass;

#define VALA_TYPE_ITERABLE (vala_iterable_get_type ())
#define VALA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_ITERABLE, ValaIterable))
#define VALA_IS_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_ITERABLE))
#define VALA_ITERABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_ITERABLE, ValaIterableIface))

typedef struct _ValaIterable ValaIterable;
typedef struct _ValaIterableIface ValaIterableIface;

#define VALA_TYPE_ITERATOR (vala_iterator_get_type ())
#define VALA_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_ITERATOR, ValaIterator))
#define VALA_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_ITERATOR))
#define VALA_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_ITERATOR, ValaIteratorIface))

typedef struct _ValaIterator ValaIterator;
typedef struct _ValaIteratorIface ValaIteratorIface;

#define VALA_TYPE_COLLECTION (vala_collection_get_type ())
#define VALA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_COLLECTION, ValaCollection))
#define VALA_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_COLLECTION))
#define VALA_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_COLLECTION, ValaCollectionIface))

typedef struct _ValaCollection ValaCollection;
typedef struct _ValaCollectionIface ValaCollectionIface;

#define VALA_TYPE_SET (vala_set_get_type ())
#define VALA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_SET, ValaSet))
#define VALA_IS_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_SET))
#define VALA_SET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALA_TYPE_SET, ValaSetIface))

typedef struct _ValaSet ValaSet;
typedef struct _ValaSetIface ValaSetIface;

struct _ValaIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*next) (ValaIterator* self);
	gpointer (*get) (ValaIterator* self);
};

struct _ValaIterableIface {
	GTypeInterface parent_iface;
	GType (*get_element_type) (ValaIterable* self);
	ValaIterator* (*iterator) (ValaIterable* self);
};

struct _ValaCollectionIface {
	GTypeInterface parent_iface;
	gboolean (*contains) (ValaCollection* self, gconstpointer item);
	gboolean (*add) (ValaCollection* self, gconstpointer item);
	gboolean (*remove) (ValaCollection* self, gconstpointer item);
	void (*clear) (ValaCollection* self);
	gint (*get_size) (ValaCollection* self);
};

struct _ValaSetIface {
	GTypeInterface parent_iface;
};



gpointer vala_collection_object_ref (gpointer instance);
void vala_collection_object_unref (gpointer instance);
GParamSpec* vala_param_spec_collection_object (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void vala_value_set_collection_object (GValue* value, gpointer v_object);
void vala_value_take_collection_object (GValue* value, gpointer v_object);
gpointer vala_value_get_collection_object (const GValue* value);
GType vala_collection_object_get_type (void) G_GNUC_CONST;
GType vala_iterator_get_type (void) G_GNUC_CONST;
GType vala_iterable_get_type (void) G_GNUC_CONST;
GType vala_collection_get_type (void) G_GNUC_CONST;
GType vala_set_get_type (void) G_GNUC_CONST;



static void vala_set_base_init (ValaSetIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * A set is a collection without duplicates.
 */
GType vala_set_get_type (void) {
	static volatile gsize vala_set_type_id__volatile = 0;
	if (g_once_init_enter (&vala_set_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaSetIface), (GBaseInitFunc) vala_set_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType vala_set_type_id;
		vala_set_type_id = g_type_register_static (G_TYPE_INTERFACE, "ValaSet", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (vala_set_type_id, VALA_TYPE_COLLECTION);
		g_once_init_leave (&vala_set_type_id__volatile, vala_set_type_id);
	}
	return vala_set_type_id__volatile;
}




